<?php
if ( ! class_exists( 'Elemento_Business_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Elemento_Business_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Elemento_Business_Plugin_Activation_WPElemento_Importer {

        private static $elemento_business_instance;
        public $elemento_business_action_count;
        public $elemento_business_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$elemento_business_instance) ) {
            self::$elemento_business_instance = new self();
          }
          return self::$elemento_business_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'elemento_business_recommended_plugins', array($this, 'elemento_business_recommended_elemento_importer_plugins_array') );

            $elemento_business_actions                   = $this->elemento_business_get_recommended_actions();
            $this->elemento_business_action_count        = $elemento_business_actions['count'];
            $this->elemento_business_recommended_actions = $elemento_business_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function elemento_business_recommended_elemento_importer_plugins_array($elemento_business_plugins){
            $elemento_business_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'elemento-business'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'elemento-business'),               
            );
            return $elemento_business_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'elemento-business-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('elemento-business-plugin-activation-script', 'elemento_business_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'elemento-business'),
                    'activating' => esc_html__('Activating', 'elemento-business'),
                    'error' => esc_html__('Error', 'elemento-business'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'elemento-business-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function elemento_business_get_recommended_actions() {

            $elemento_business_act_count  = 0;
            $elemento_business_actions_todo = get_option( 'recommending_actions', array());

            $elemento_business_plugins = $this->elemento_business_get_recommended_plugins();

            if ($elemento_business_plugins) {
                foreach ($elemento_business_plugins as $elemento_business_key => $elemento_business_plugin) {
                    $elemento_business_action = array();
                    if (!isset($elemento_business_plugin['slug'])) {
                        continue;
                    }

                    $elemento_business_action['id']   = 'install_' . $elemento_business_plugin['slug'];
                    $elemento_business_action['desc'] = '';
                    if (isset($elemento_business_plugin['desc'])) {
                        $elemento_business_action['desc'] = $elemento_business_plugin['desc'];
                    }

                    $elemento_business_action['name'] = '';
                    if (isset($elemento_business_plugin['name'])) {
                        $elemento_business_action['title'] = $elemento_business_plugin['name'];
                    }

                    $elemento_business_link_and_is_done  = $this->elemento_business_get_plugin_buttion($elemento_business_plugin['slug'], $elemento_business_plugin['name'], $elemento_business_plugin['function']);
                    $elemento_business_action['link']    = $elemento_business_link_and_is_done['button'];
                    $elemento_business_action['is_done'] = $elemento_business_link_and_is_done['done'];
                    if (!$elemento_business_action['is_done'] && (!isset($elemento_business_actions_todo[$elemento_business_action['id']]) || !$elemento_business_actions_todo[$elemento_business_action['id']])) {
                        $elemento_business_act_count++;
                    }
                    $elemento_business_recommended_actions[] = $elemento_business_action;
                    $elemento_business_actions_todo[]        = array('id' => $elemento_business_action['id'], 'watch' => true);
                }
                return array('count' => $elemento_business_act_count, 'actions' => $elemento_business_recommended_actions);
            }

        }

        public function elemento_business_get_recommended_plugins() {

            $elemento_business_plugins = apply_filters('elemento_business_recommended_plugins', array());
            return $elemento_business_plugins;
        }

        public function elemento_business_get_plugin_buttion($slug, $name, $function) {
                $elemento_business_is_done      = false;
                $elemento_business_button_html  = '';
                $elemento_business_is_installed = $this->is_plugin_installed($slug);
                $elemento_business_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $elemento_business_is_activeted = (class_exists($function)) ? true : false;
                if (!$elemento_business_is_installed) {
                    $elemento_business_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $elemento_business_plugin_install_url = wp_nonce_url($elemento_business_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $elemento_business_button_html        = sprintf('<a class="elemento-business-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($elemento_business_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'elemento-business'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'elemento-business')
                    );
                } elseif ($elemento_business_is_installed && !$elemento_business_is_activeted) {

                    $elemento_business_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($elemento_business_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $elemento_business_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $elemento_business_button_html = sprintf('<a class="elemento-business-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($elemento_business_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'elemento-business'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'elemento-business')
                    );
                } elseif ($elemento_business_is_activeted) {
                    $elemento_business_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'elemento-business'));
                    $elemento_business_is_done     = true;
                }

                return array('done' => $elemento_business_is_done, 'button' => $elemento_business_button_html);
            }
        public function is_plugin_installed($slug) {
            $elemento_business_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $elemento_business_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($elemento_business_installed_plugins[$elemento_business_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $elemento_business_keys = array_keys($this->get_installed_plugins());
            foreach ($elemento_business_keys as $elemento_business_key) {
                if (preg_match('|^' . $slug . '/|', $elemento_business_key)) {
                    return $elemento_business_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Elemento_Business_Plugin_Activation_WPElemento_Importer::get_instance();